
window.Graph = function(canvas){

var kontekst = canvas.getContext("2d");
var sc = canvas.width;
var vc = canvas.height;

var grafik=this;

var nt=false;
var ind;
var korakY,korakZ,korakF;
grafik.yz='y';

// Podešavanje centra koordinatnog sistema u centru canvasa
// sa osama u opsegu (-1,1)
kontekst.save();
kontekst.translate(sc/2, vc/2);
kontekst.scale(sc/2, -vc/2);
kontekst.lineWidth=2/vc;

var flag = false,
    prethodniX = 0,
    trenutniX = 0,
    prethodniY = 0,
    trenutniY = 0;
	
var koordGraf3d=[];
var koordGrafCanv=[];
var koordGrafCanvNorm=[];
	
canvas.addEventListener("mousemove", function (e) {
	nadjiXY('move', e)
}, false);
canvas.addEventListener("touchmove", function (e) {
	nadjiXY('tmove', e)
}, false);
canvas.addEventListener("mousedown", function (e) {
	nadjiXY('down', e)
}, false);
canvas.addEventListener("mouseup", function (e) {
	nadjiXY('up', e)
}, false);
canvas.addEventListener("mouseout", function (e) {
	nadjiXY('out', e)
}, false);
canvas.addEventListener("click", function (e) {
	nadjiXY('click', e)
}, false);
canvas.addEventListener("dblclick", function (e) {
	nadjiXY('dblclick', e)
}, false);

if (canvas.addEventListener) {
// IE9+, Chrome, Safari, Opera
canvas.addEventListener("mousewheel", skrolMisFukcija, false);
// Firefox
canvas.addEventListener("DOMMouseScroll",skrolMisFukcija, false);
}



function skrolMisFukcija(e) {
	var e = window.event || e; 
	if (e.preventDefault) e.preventDefault();
	var delta = Math.max(-1, Math.min(1, (e.wheelDelta || -e.detail)));

	grafik.zoom=Math.round(Math.min(300,Math.max(10,grafik.zoom+grafik.zoom*0.1*delta)));
	if (grafik.type=='plot') {grafik.plot()} 
	else if (grafik.type=='plot3'){grafik.plot3()}
	else if (grafik.type=='stem'){grafik.stem()}
	
	return false;
}
	
function nadjiXY(res, e) {
    if (res == 'down') {
        prethodniX = trenutniX;
        prethodniY = trenutniY;
        trenutniX = e.clientX - canvas.offsetLeft;
        trenutniY = e.clientY - canvas.offsetTop;

        flag = true;
        
        }
    
    if (res == 'up' || res == "out") {
        flag = false;
    }
    if (res == 'move') {
        if (flag) {
            prethodniX = trenutniX;
            prethodniY = trenutniY;
            trenutniX = e.clientX - canvas.offsetLeft;
            trenutniY = e.clientY - canvas.offsetTop;
			rot();
        }
    }
	
	if (res == 'tmove') {
	e.preventDefault();
        var touchobj = e.changedTouches[0];
            prethodniX = trenutniX;
            prethodniY = trenutniY;
            trenutniX = parseInt(touchobj.clientX) - canvas.offsetLeft;
            trenutniY = parseInt(touchobj.clientY) - canvas.offsetTop;
			rot();
        
    }

	if (res == 'click') {
        prethodniX = trenutniX;
        prethodniY = trenutniY;
        trenutniX = e.clientX - canvas.offsetLeft;
        trenutniY = e.clientY - canvas.offsetTop;
		
		for (var i=0;i<koordGrafCanv.length;i++){
			if (Math.abs(trenutniX-koordGrafCanv[i][0])<5
				&&Math.abs(trenutniY-koordGrafCanv[i][1])<5){
					nt=true;
					ind=i;
			if (grafik.type=='plot') {grafik.plot()} 
			else if (grafik.type=='plot3'){grafik.plot3()}
			else if (grafik.type=='stem'){grafik.stem()}

					break;
		}
		
	}
       
	}


	if (res == 'dblclick') {
		nt=false;
		grafik.selX="";
		grafik.selY="";
		grafik.selZ="";
if (grafik.type=='plot') {grafik.plot()} 
else if (grafik.type=='plot3'){grafik.plot3()}
else if (grafik.type=='stem'){grafik.stem()}
}	

}  

function nacrtajTacku(koord, r){
		kontekst.save();
		kontekst.setTransform(1,0,0,1,0,0);
		kontekst.beginPath();
		kontekst.arc(koord[0],koord[1],r,0,2*Math.PI);
		kontekst.fillStyle="blue";
		kontekst.fill();
		kontekst.restore();
	
}

function rot(){
var rx1=(trenutniY-prethodniY)/2
var rz1=(trenutniX-prethodniX)/2;
grafik.rotX+=rx1;
grafik.rotZ+=rz1;
if (grafik.type=='plot') {grafik.plot()} 
else if (grafik.type=='plot3'){grafik.plot3()}
else if (grafik.type=='stem'){grafik.stem()}
}



 // dx,dy,dz-koordinate pogleda						
var dy=-4.5;
var dx=0.5;
var dz=0.45;
var koordTacke =[];

function defKoordTacke(){
	
	koordTacke = [	[0,0,0],[1,0,0],[1,1,0],[0,1,0],
					[0,0,1],[1,0,1],[1,1,1],[0,1,1] ];
			
	
	mapaLinija = [	[0,1],[4,5],[6,7],[2,3],
					[0,3],[1,2],[5,6],[4,7],
					[0,4],[1,5],[2,6],[3,7]	];
	

}

 function defKoordTacke2d(){
	
	koordTacke = [	[0,0.5,0],[1,0.5,0],[1,0.5,0],[0,0.5,0],
					[0,0.5,1],[1,0.5,1],[1,0.5,1],[0,0.5,1] ];
			
	mapaLinija = [	[0,1],[1,5],[5,4],[4,0]];
	

}

function persp(p) { 
	return [(p[0]-dx) / (p[1]-dy)*6, (p[2]-dz) / (p[1]-dy)*6] 
}
function transliraj(x, y, z) {
  return [[1, 0, 0, x], [0, 1, 0, y], [0, 0, 1, z]]
}
// jedinicna matrica, preko translate f-je
function jedinicnaMatrica() { return transliraj(0, 0, 0) }

// rotiranje po x-osi, vraća prve tri vrste matrice
function rotirajOkoX(theta) {
theta=theta/180*Math.PI;
  var s = Math.sin(theta)
  var c = Math.cos(theta)
   return [[1, 0, 0, 0], [0, c, -s, 0], [0, s, c, 0]]
}
// rotiranje po y-osi, vraća prve tri vrste matrice
function rotirajOkoY(theta) {
theta=theta/180*Math.PI;
  var s = Math.sin(theta)
  var c = Math.cos(theta)
  return [[c, 0, -s, 0], [0, 1, 0, 0], [s, 0, c, 0]]
}

// rotiranje po z-osi, vraća prve tri vrste matrice
function rotirajOkoZ(theta) {
theta=theta/180*Math.PI;
  var s = Math.sin(theta)
  var c = Math.cos(theta)
  return [[c, -s, 0, 0], [s, c, 0, 0], [0, 0, 1, 0]]
}


// mnozenje 2 matrice, obrnuto
function mnozenjeMatrica(x1, x2) {
  var rv = [[0, 0, 0, 0], [0, 0, 0, 0], [0, 0, 0, 0]]
  for (var ii = 0; ii < 3; ii++) {
    rv[ii][3] = x2[ii][3]
    for (var jj = 0; jj < 3; jj++) {
      rv[ii][3] += x1[jj][3] * x2[ii][jj]
      for (var kk = 0; kk < 3; kk++) {
        rv[ii][jj] += x1[kk][jj] * x2[ii][kk]
      }
    }
  }
  return rv
}
// mnozenje vise matrica pomocu mnozenja 2, obrnuto
function mnozenjeMatrica_n(nizMatrica) {
  var rv = jedinicnaMatrica()
  for (var ii = 0; ii < nizMatrica.length; ii++) rv = mnozenjeMatrica(rv, nizMatrica[ii]) 
  return rv
}
// mnozenje transformacije i tacke
function transormacijaXTacka(transform, p) {
  var rezultat = []
  for (var ii = 0; ii < 3; ii++) {
    var rv = transform[ii][3]
    for (var jj = 0; jj < 3; jj++) rv += transform[ii][jj] * p[jj]
    rezultat.push(rv)
  }
  return rezultat
}
// mnozenje vise tacaka s transformacijom,
// promenjiva "tacke" je niz tacaka
function transormacijaXNizTacaka(xf, tacke) {
  var xp = []
  for (var ii = 0; ii < tacke.length; ii++) {
    xp.push(transormacijaXTacka(xf, tacke[ii]))
  }
  return xp
 }

 
 
 
// crtanje linije od početne do krajnje tacke
function crtLin(a,b,c,d) {
	kontekst.moveTo(a,b);
	kontekst.lineTo(c,d);
} 


var xmin,xmax,korak_x;

function funkcijaY(x){
	return eval(grafik.y);
}
function funkcijaZ(x){

		return eval(grafik.z);
}


function funkcijaF1(x){

		return eval(grafik.f1);
}

function funkcijaF2(x){

		return eval(grafik.f2);
}

function funkcijaF3(x){

		return eval(grafik.f3);
}

function funkcijaF4(x){

		return eval(grafik.f4);
}

function funkcijaF5(x){

		return eval(grafik.f5);
}

function maksFje(mxfja){
	
	var x=xmin;
	var ymaxset=false;
	
	while (x<=xmax){
	
		var y=mxfja(x);
		
		if(isFinite(y)){
			if(ymaxset){
					if (y>ymax){ymax=y}
			}else{
					var ymax=y;
					ymaxset=true;
			}
		}
	x+=korak_x;
	}
	
	return ymax;
}
function minFje(mnfja){
	
	var x=xmin;
	var yminset=false;
	while (x<=xmax){
	
		var y=mnfja(x);
		
		if(isFinite(y)){	
			if(yminset){
				if (y<ymin){ymin=y}
			}else{
				var ymin=y;
				yminset=true;
			}
		}
	x+=korak_x;
	}
	
	return ymin;
}

function zaok(temp,x)
	{
		var dec=(temp.toString().split('.')[1] || []).length;
		if (dec>0){
			x=Math.round(x*Math.pow(10,dec))/Math.pow(10,dec);
		}
		return x;
	}

function back() {
var grd=kontekst.createLinearGradient(-1,1,1,-1);
grd.addColorStop(0,"#F5E6FF");
grd.addColorStop(1,"#EBF5FF");
kontekst.fillStyle=grd;
kontekst.rect(-1,-1,2,2);
kontekst.fill();
}

function ugao360(ugao){
	ugao=ugao-360*Math.floor(ugao/360);
	return ugao;
}


this.plot3 = function (){
if (typeof grafik.rotX=="undefined"||
	typeof grafik.rotZ=="undefined"){
grafik.rotX=15;
grafik.rotZ=35;
}
if (typeof grafik.zoom=="undefined"){
grafik.zoom=100;}
grafik.rotX=ugao360(grafik.rotX);
grafik.rotZ=ugao360(grafik.rotZ);
grafik.type='plot3';
dy=-4.5*100/grafik.zoom;

defKoordTacke();

	
if (typeof grafik.xmin=="undefined"||
	typeof grafik.xmax=="undefined"||
	typeof grafik.korak=="undefined"){
		var x_niz=grafik.x.split(":");
		xmin=parseFloat(x_niz[0]);
		korak_x=parseFloat(x_niz[1]);
		xmax=parseFloat(x_niz[2]);
	grafik.xmin=xmin;
	grafik.xmax=xmax;
	grafik.korak=korak_x;
}else{

	if (xmin!=grafik.xmin||
		xmax!=grafik.xmax||
		korak_x!=grafik.korak) {
		grafik.selX="";
		grafik.selY="";
		grafik.selZ="";
		nt=false}
	
	xmin=parseFloat(grafik.xmin);
	xmax=parseFloat(grafik.xmax);
	korak_x=parseFloat(grafik.korak);

}
var pocetak=true;
var asimptota=false;
var x=xmin;

var ymax=maksFje(funkcijaY),
	ymin=minFje(funkcijaY),
	zmax=maksFje(funkcijaZ),
	zmin=minFje(funkcijaZ);
	
	kontekst.clearRect(-1,-1,2,2);
	back();
	kontekst.beginPath();
	kontekst.lineWidth=2/vc*2.5;	


var transformacije=[transliraj(-0.5, -0.5, -0.5),
					rotirajOkoZ(0+grafik.rotZ),
					rotirajOkoX(0+grafik.rotX),					
					transliraj(0.5, 0.5, 0.5)];

koordGraf3d=[];
koordGrafCanvNorm=[];
koordGrafCanv=[];
while (x<=xmax){
		var y=funkcijaY(x);
		var z=funkcijaZ(x);
		var grafTacka=[];
		
		// Upisivanje originalnih tačaka u niz
		koordGraf3d.push([x,y,z]);
		// Skaliranje vrednosti u opseg od -1 do 1
		grafTacka[0]=(x-xmin)/(xmax-xmin),
		grafTacka[1]=(y-ymin)/(ymax-ymin),
		grafTacka[2]=(z-zmin)/(zmax-zmin);
		// transformacije nad tačkama grafika
		grafTacka=transormacijaXTacka(mnozenjeMatrica_n(transformacije),
					grafTacka);
		// Perspektivna projekcija
		var xy2d=persp([grafTacka[0],
						grafTacka[1],
						grafTacka[2]]);
		
		koordGrafCanv.push([xy2d[0]*sc/2+sc/2,vc/2-xy2d[1]*vc/2]);
		
		//	Pozicioniranje za početak iscrtavanja grafika
		if (pocetak){
			if (isFinite(y)&&!isNaN(y)&&isFinite(z)&&!isNaN(z)){
				kontekst.moveTo(xy2d[0],xy2d[1]);
				
				pocetak=false;
			}
		
		//	Ukoliko je vrednost funkcije beskonačna,
		//	sprečava se iscrtavanje asimptote
		}else if(!pocetak&&(!isFinite(y)||!isFinite(z))){
				asimptota=true;
		}else{	
			if (asimptota){
				kontekst.moveTo(xy2d[0],xy2d[1]);
				asimptota=false;
			}else{
				//	Iscrtavanje grafika
				kontekst.strokeStyle = 'red';
				kontekst.lineTo(xy2d[0],xy2d[1]);
				
			}
		}
		
		x+=korak_x;
		
	}
kontekst.stroke();


	
	// 3d transformacija koordinatnog sistema
	koordTacke=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
					koordTacke);
	
	
	function crtice(){
		if (kontekst.setLineDash) {
				kontekst.setLineDash([10/vc,20/vc])
		}else if(typeof kontekst.mozDash!="undefined"){
				kontekst.mozDash=[10/vc,20/vc];
		}
	}
	
	function punaLinija() {
		if (kontekst.setLineDash) {
			kontekst.setLineDash([null])
		}else if(typeof kontekst.mozDash!="undefined"){
			kontekst.mozDash=[];
		}
	}
	kontekst.beginPath();
	kontekst.lineWidth=2/vc;	
	kontekst.strokeStyle = 'black';
	crtice();
	
	
	var w=[];
	w[2]=3-Math.floor(grafik.rotZ/90);
	w[0]=Math.floor(grafik.rotX/90);
	w[1]=Math.floor(grafik.rotZ/180);
	if (grafik.rotZ>90&&grafik.rotZ<=270){
		if (w[0]==0) w[0]=3;
	}
	if (grafik.rotX>90&&grafik.rotX<=180){
		if (w[1]==0) w[1]=3;
		if (w[1]==1) w[1]=2;
	}
	
	
	
	// iscrtavanje linija koordinatnog sistema
	for (var i=0;i<12;i++){
		
		if (i==w[0]||i-4==w[1]||i-8==w[2]){ 
			kontekst.stroke();
			kontekst.beginPath();
			punaLinija();
		}
		
		crtLin(	persp(koordTacke[mapaLinija[i][0]])[0],persp(koordTacke[mapaLinija[i][0]])[1],
				persp(koordTacke[mapaLinija[i][1]])[0],persp(koordTacke[mapaLinija[i][1]])[1]);
	
		kontekst.stroke();
		kontekst.beginPath();
		crtice();
	}
	
	punaLinija();

	//podela na 5 podeoka od 0 do 5
	var podeociX=podeli_ose(xmin,xmax,7);
	var podeociY=podeli_ose(ymin,ymax,7,"y");
	var podeociZ=podeli_ose(zmin,zmax,7,"z");
	kontekst.beginPath();
	var tp2d2=[];
	var tp2d2Y=[];
	var tp2d2Z=[];
	// Određivanje koordinata podeoka za x-osu
	for (var i=0;i<podeociX.length;i++){
		var tpt=(podeociX[i]-xmin)/(xmax-xmin);
		var koordTemp=koordTacke;
		defKoordTacke();
		var tp3d=[	[tpt,koordTacke[mapaLinija[w[0]][0]][1],koordTacke[mapaLinija[w[0]][0]][2]],
					[tpt,koordTacke[mapaLinija[w[0]][0]][1]-0.01,koordTacke[mapaLinija[w[0]][0]][2]-0.01]];
		koordTacke=koordTemp;
		tp3d=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
						tp3d);
		var tp2d1=persp(tp3d[0]);
		tp2d2[i]=persp(tp3d[1]);
		kontekst.moveTo(tp2d1[0],tp2d1[1]);
		kontekst.lineTo(tp2d2[i][0],tp2d2[i][1]);
	}
	// Određivanje koordinata podeoka za Y-osu
	for (var i=0;i<podeociY.length;i++){
		var tpt=(podeociY[i]-ymin)/(ymax-ymin);
		
		var koordTemp=koordTacke;
		defKoordTacke();
		var tp3d=[	[koordTacke[mapaLinija[w[1]+4][0]][0],tpt,koordTacke[mapaLinija[w[1]+4][0]][2]],
					[koordTacke[mapaLinija[w[1]+4][0]][0]-0.01,tpt,koordTacke[mapaLinija[w[1]+4][0]][2]-0.01]];
		koordTacke=koordTemp;
		tp3d=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
						tp3d);
		var tp2d1=persp(tp3d[0]);
		tp2d2Y[i]=persp(tp3d[1]);
		kontekst.moveTo(tp2d1[0],tp2d1[1]);
		kontekst.lineTo(tp2d2Y[i][0],tp2d2Y[i][1]);
	}
		// Određivanje koordinata podeoka za Z-osu
		var kp = [[-1,-1],[1,-1],[1,1],[-1,1]];
		for (var i=0;i<podeociZ.length;i++){
		var tpt=(podeociZ[i]-zmin)/(zmax-zmin);
		var koordTemp=koordTacke;
		defKoordTacke();
		var tp3d=[	[koordTacke[w[2]][0],koordTacke[w[2]][1],tpt],
					[koordTacke[w[2]][0]+kp[w[2]][0]*0.01,koordTacke[w[2]][1]+kp[w[2]][1]*0.01,tpt]];
		koordTacke=koordTemp;
		tp3d=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
						tp3d);
		var tp2d1=persp(tp3d[0]);
		tp2d2Z[i]=persp(tp3d[1]);
		kontekst.moveTo(tp2d1[0],tp2d1[1]);
		kontekst.lineTo(tp2d2Z[i][0],tp2d2Z[i][1]);
	}
	
	kontekst.stroke();
	
	
	kontekst.scale(2/sc,-2/vc); 				
	var velFonta=vc/50-dy/-4.5;
	kontekst.font=velFonta+"px Arial";
	kontekst.textBaseline="top";
	kontekst.fillStyle="black";
	for (var i=0;i<podeociX.length;i++){
		var podX=tp2d2[i][0]*sc/2-kontekst.measureText(podeociX[i]).width/2;
		
		var podY=-tp2d2[i][1]*vc/2+velFonta*0.15;
		kontekst.fillText(podeociX[i],podX,podY);
	}
	
	for (var i=0;i<podeociY.length;i++){
		var podX=tp2d2Y[i][0]*sc/2-kontekst.measureText(zaok(korakY,podeociY[i])).width/2;
		
		var podY=-tp2d2Y[i][1]*vc/2+velFonta*0.15;
		kontekst.fillText(zaok(korakY,podeociY[i]),podX,podY);
	}
	
	for (var i=0;i<podeociZ.length;i++){
		var podX=tp2d2Z[i][0]*sc/2-kontekst.measureText(zaok(korakZ,podeociZ[i])).width/2;
		
		var podY=-tp2d2Z[i][1]*vc/2+velFonta*0.15;
		kontekst.fillText(zaok(korakZ,podeociZ[i]),podX,podY);
	}
	
	
	
	
	
	kontekst.scale(sc/2,-vc/2); 				
	
	
	if (nt){
		grafik.selX=zaok(korak_x,koordGraf3d[ind][0]);
		grafik.selY=koordGraf3d[ind][1];
		grafik.selZ=koordGraf3d[ind][2];
		nacrtajTacku(koordGrafCanv[ind],4-(4-dy)/14);
	
		}

	}

this.plot = function (){

if (typeof grafik.rotX=="undefined"||
	typeof grafik.rotZ=="undefined"){
grafik.rotX=0;
grafik.rotZ=0;
}
if (typeof grafik.zoom=="undefined"){
grafik.zoom=145;}
grafik.rotX=ugao360(grafik.rotX);
grafik.rotZ=ugao360(grafik.rotZ);

grafik.type='plot';
dy=-4.5*100/grafik.zoom;

defKoordTacke2d()

if (typeof grafik.xmin=="undefined"||
	typeof grafik.xmax=="undefined"||
	typeof grafik.korak=="undefined"){
		var x_niz=grafik.x.split(":");
		xmin=parseFloat(x_niz[0]);
		korak_x=parseFloat(x_niz[1]);
		xmax=parseFloat(x_niz[2]);
	grafik.xmin=xmin;
	grafik.xmax=xmax;
	grafik.korak=korak_x;
}else{



	if (xmin!=grafik.xmin||
		xmax!=grafik.xmax||
		korak_x!=grafik.korak) {
		grafik.selX="";
		grafik.selY="";
		grafik.selZ="";
		nt=false}
	
	xmin=parseFloat(grafik.xmin);
	xmax=parseFloat(grafik.xmax);
	korak_x=parseFloat(grafik.korak);

}

var pocetak=true;
var asimptota=false;
var x=xmin;
var fmm = [[],[],[],[],[],[]];
fmm[1][0]=maksFje(funkcijaF1);
fmm[1][1]=minFje(funkcijaF1);
fmm[2][0]=maksFje(funkcijaF2);
fmm[2][1]=minFje(funkcijaF2);
fmm[3][0]=maksFje(funkcijaF3);
fmm[3][1]=minFje(funkcijaF3);
fmm[4][0]=maksFje(funkcijaF4);
fmm[4][1]=minFje(funkcijaF4);
fmm[5][0]=maksFje(funkcijaF5);
fmm[5][1]=minFje(funkcijaF5);

	var minMaxPoc=1;
//	alert(maxMax);
for (iii=1;iii<6;iii++){
	if (typeof fmm[iii][0]=="undefined"||typeof fmm[iii][1]=="undefined"){continue;}
	if (minMaxPoc==1){
		var maxMax=fmm[iii][0];
		var minMin=fmm[iii][1];
		minMaxPoc=0;
	}
	maxMax=Math.max(maxMax,fmm[iii][0]);
	minMin=Math.min(minMin,fmm[iii][1]);
}
	

	kontekst.clearRect(-1,-1,2,2);
	back();
	kontekst.beginPath();
	kontekst.lineWidth=2/vc*2.5;	

var transformacije=[transliraj(-0.5, -0.5, -0.5),
					rotirajOkoZ(0+grafik.rotZ),
					rotirajOkoX(0+grafik.rotX),					
					transliraj(0.5, 0.5, 0.5)];

					koordGraf3d=[];
koordGrafCanvNorm=[];
koordGrafCanv=[];
function IzracunajY(fjaa){
	var tempXYZ=[];
	var x=xmin;	
	var iii=0;
	while (x<=xmax){
			var y=fjaa(x);
			var z=0.5;
			var grafTacka=[];

			
	tempXYZ[iii]=[x,y,z];
	iii++;
	x+=korak_x;
	}
return tempXYZ;
}
	
var f1=IzracunajY(funkcijaF1);
var f2=IzracunajY(funkcijaF2);
var f3=IzracunajY(funkcijaF3);
var f4=IzracunajY(funkcijaF4);
var f5=IzracunajY(funkcijaF5);
var grafTacka=[];
 
 var mixBoja=["red","green","blue","orange","violet"]
 var grafBojaID=0;
 function crtanjeGrafika (tempfja) {
kontekst.strokeStyle = mixBoja[grafBojaID];
grafBojaID++;
 kontekst.beginPath();
 for (var iii=0;iii<tempfja.length;iii++){

koordGraf3d[iii]=tempfja[iii];
 var x=tempfja[iii][0];
 var y=tempfja[iii][1];
 var z=tempfja[iii][2];
  
 grafTacka[0]=(tempfja[iii][0]-xmin)/(xmax-xmin);
 grafTacka[1]=0.5;
 grafTacka[2]=(tempfja[iii][1]-minMin)/(maxMax-minMin)
 
 
 grafTacka=transormacijaXTacka(mnozenjeMatrica_n(transformacije),
					grafTacka);
		
		var xy2d=persp([grafTacka[0],
						grafTacka[1],
						grafTacka[2]]);

						koordGrafCanv.push([xy2d[0]*sc/2+sc/2,vc/2-xy2d[1]*vc/2]);
		
		//	Pozicioniranje za početak iscrtavanja grafika
		
		if (pocetak){
			if (isFinite(y)&&!isNaN(y)&&isFinite(z)&&!isNaN(z)){
				kontekst.moveTo(xy2d[0],xy2d[1]);
				
				pocetak=false;
			}
		

		//	Ukoliko je vrednost funkije beskonačna,
		//	sprečava se iscrtavanje asimptote
		}else if(!pocetak&&(!isFinite(y)||!isFinite(z))){
				asimptota=true;
		}else{	
			if (asimptota){
				kontekst.moveTo(xy2d[0],xy2d[1]);
				asimptota=false;
			}else{

				//	Iscrtavanje grafika

				kontekst.lineTo(xy2d[0],xy2d[1]);
				
			}
		}
 
 }

 kontekst.stroke();

} //crtanjeGrafika
	
crtanjeGrafika(f1);
crtanjeGrafika(f2);
crtanjeGrafika(f3);
crtanjeGrafika(f4);
crtanjeGrafika(f5);



	// 3d transformacija koordinatnog sistema
	koordTacke=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
					koordTacke);

	kontekst.lineWidth=2/vc;	
	kontekst.strokeStyle = 'black';

	// iscrtavanje linija koordinatnog sistema
	for (var i=0;i<4;i++){
		
		
			kontekst.beginPath();
		
		crtLin(	persp(koordTacke[mapaLinija[i][0]])[0],persp(koordTacke[mapaLinija[i][0]])[1],
				persp(koordTacke[mapaLinija[i][1]])[0],persp(koordTacke[mapaLinija[i][1]])[1]);
	
		kontekst.stroke();
		kontekst.beginPath();
		
	}

	//podela na 5 podeoka od 0 do 5
	var podeociX=podeli_ose(xmin,xmax,7);
	var podeociF=podeli_ose(minMin,maxMax,7);
	kontekst.beginPath();
	var tp2d2=[];
	var tp2d2Y=[];
	var tp2d2Z=[];
	for (var i=0;i<podeociX.length;i++){
		var tpt=(podeociX[i]-xmin)/(xmax-xmin);

		var koordTemp=koordTacke;
		defKoordTacke2d();
		var tp3d=[	[tpt,koordTacke[mapaLinija[0][0]][1],koordTacke[mapaLinija[0][0]][2]],
					[tpt,koordTacke[mapaLinija[0][0]][1]-0.01,koordTacke[mapaLinija[0][0]][2]-0.01]];
		koordTacke=koordTemp;
		tp3d=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
						tp3d);
		var tp2d1=persp(tp3d[0]);
		tp2d2[i]=persp(tp3d[1]);
		kontekst.moveTo(tp2d1[0],tp2d1[1]);
		kontekst.lineTo(tp2d2[i][0],tp2d2[i][1]);
	}

		var kp = [[-1,-1],[1,-1],[1,1],[-1,1]];
		for (var i=0;i<podeociF.length;i++){
		var tpt=(podeociF[i]-minMin)/(maxMax-minMin);
		var koordTemp=koordTacke;
		defKoordTacke2d();
		var tp3d=[	[koordTacke[2][0],koordTacke[2][1],tpt],
					[koordTacke[2][0]+kp[2][0]*0.01,koordTacke[2][1]+kp[2][1]*0.01,tpt]];
		koordTacke=koordTemp;
		tp3d=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
						tp3d);

		var tp2d1=persp(tp3d[0]);
		tp2d2Z[i]=persp(tp3d[1]);
		kontekst.moveTo(tp2d1[0],tp2d1[1]);
		kontekst.lineTo(tp2d2Z[i][0],tp2d2Z[i][1]);
	}
	
	kontekst.stroke();

	
	kontekst.scale(2/sc,-2/vc); 				
	var velFonta=vc/50-dy/-4.5;
	kontekst.font=velFonta+"px Arial";
	kontekst.textBaseline="top";
	kontekst.fillStyle="black";
	for (var i=0;i<podeociX.length;i++){
		var podX=tp2d2[i][0]*sc/2-kontekst.measureText(podeociX[i]).width/2;
		
		var podF=-tp2d2[i][1]*vc/2+velFonta*0.15;
		kontekst.fillText(podeociX[i],podX,podF);
	}

	for (var i=0;i<podeociF.length;i++){
		kontekst.textBaseline="top";
		var podX=tp2d2Z[i][0]*sc/2+kontekst.measureText(zaok(korakF,podeociF[i])).width/2;
		kontekst.textBaseline="middle";
		var podF=-tp2d2Z[i][1]*vc/2+velFonta*0.15;
		kontekst.fillText(zaok(korakF,podeociF[i]),podX,podF);
	}

	kontekst.scale(sc/2,-vc/2); 				
	
	
	if (nt){
		grafik.selX=zaok(korak_x,koordGraf3d[ind][0]);
		grafik.selY=koordGraf3d[ind][1];
		grafik.selZ=koordGraf3d[ind][2];
		nacrtajTacku(koordGrafCanv[ind],4-(4-dy)/14);
	
		}

} //plot


this.stem = function (){

if (typeof grafik.rotX=="undefined"||
	typeof grafik.rotZ=="undefined"){
grafik.rotX=0;
grafik.rotZ=0;
}
if (typeof grafik.zoom=="undefined"){
grafik.zoom=145;}
grafik.rotX=ugao360(grafik.rotX);
grafik.rotZ=ugao360(grafik.rotZ);

grafik.type='stem';
dy=-4.5*100/grafik.zoom;

defKoordTacke2d()

if (typeof grafik.xmin=="undefined"||
	typeof grafik.xmax=="undefined"||
	typeof grafik.korak=="undefined"){
		var x_niz=grafik.x.split(":");
		xmin=parseFloat(x_niz[0]);
		korak_x=parseFloat(x_niz[1]);
		xmax=parseFloat(x_niz[2]);
	grafik.xmin=xmin;
	grafik.xmax=xmax;
	grafik.korak=korak_x;
}else{



	if (xmin!=grafik.xmin||
		xmax!=grafik.xmax||
		korak_x!=grafik.korak) {
		grafik.selX="";
		grafik.selY="";
		grafik.selZ="";
		nt=false}
	
	xmin=parseFloat(grafik.xmin);
	xmax=parseFloat(grafik.xmax);
	korak_x=parseFloat(grafik.korak);

}

var pocetak=true;
var asimptota=false;
var x=xmin;
var fmm = [[],[],[],[],[],[]];
fmm[1][0]=maksFje(funkcijaF1);
fmm[1][1]=minFje(funkcijaF1);
fmm[2][0]=maksFje(funkcijaF2);
fmm[2][1]=minFje(funkcijaF2);
fmm[3][0]=maksFje(funkcijaF3);
fmm[3][1]=minFje(funkcijaF3);
fmm[4][0]=maksFje(funkcijaF4);
fmm[4][1]=minFje(funkcijaF4);
fmm[5][0]=maksFje(funkcijaF5);
fmm[5][1]=minFje(funkcijaF5);

	var minMaxPoc=1;
//	alert(maxMax);
for (iii=1;iii<6;iii++){
	if (typeof fmm[iii][0]=="undefined"||typeof fmm[iii][1]=="undefined"){continue;}
	if (minMaxPoc==1){
		var maxMax=fmm[iii][0];
		var minMin=fmm[iii][1];
		minMaxPoc=0;
	}
	maxMax=Math.max(maxMax,fmm[iii][0]);
	minMin=Math.min(minMin,fmm[iii][1]);
}
	

	kontekst.clearRect(-1,-1,2,2);
	back();
	kontekst.beginPath();
	kontekst.lineWidth=2/vc*2.5;	

var transformacije=[transliraj(-0.5, -0.5, -0.5),
					rotirajOkoZ(0+grafik.rotZ),
					rotirajOkoX(0+grafik.rotX),					
					transliraj(0.5, 0.5, 0.5)];

					koordGraf3d=[];
koordGrafCanvNorm=[];
koordGrafCanv=[];
function IzracunajY(fjaa){
	var tempXYZ=[];
	var x=xmin;	
	var iii=0;
	while (x<=xmax){
			var y=fjaa(x);
			var z=0.5;
			var grafTacka=[];

			
	tempXYZ[iii]=[x,y,z];
	iii++;
	x+=korak_x;
	}
return tempXYZ;
}
	
var f1=IzracunajY(funkcijaF1);
var f2=IzracunajY(funkcijaF2);
var f3=IzracunajY(funkcijaF3);
var f4=IzracunajY(funkcijaF4);
var f5=IzracunajY(funkcijaF5);
var grafTacka=[];
var grafTackaX=[];
 
 var mixBoja=["red","green","blue","orange","violet"]
 var grafBojaID=0;
 function crtanjeGrafika (tempfja) {
kontekst.strokeStyle = mixBoja[grafBojaID];
grafBojaID++;
 kontekst.beginPath();
 for (var iii=0;iii<tempfja.length;iii++){

koordGraf3d[iii]=tempfja[iii];
 var x=tempfja[iii][0];
 var y=tempfja[iii][1];
 var z=tempfja[iii][2];
  
 grafTacka[0]=(tempfja[iii][0]-xmin)/(xmax-xmin);
 grafTacka[1]=0.5;
 grafTacka[2]=(tempfja[iii][1]-minMin)/(maxMax-minMin)
 
 
 grafTackaX[0]=(tempfja[iii][0]-xmin)/(xmax-xmin);
 grafTackaX[1]=0.5;
 grafTackaX[2]=(-minMin)/(maxMax-minMin);
 
 
 grafTacka=transormacijaXTacka(mnozenjeMatrica_n(transformacije),
					grafTacka);


 grafTackaX=transormacijaXTacka(mnozenjeMatrica_n(transformacije),
					grafTackaX);

		var xy2d=persp([grafTacka[0],
						grafTacka[1],
						grafTacka[2]]);
						
				var x2d=persp([grafTackaX[0],
						grafTackaX[1],
						grafTackaX[2]]);

						koordGrafCanv.push([xy2d[0]*sc/2+sc/2,vc/2-xy2d[1]*vc/2]);
	

	//	Pozicioniranje za početak iscrtavanja grafika
				kontekst.beginPath();
				kontekst.arc(xy2d[0],xy2d[1],7/((sc+vc)/2)*grafik.zoom/100,0,2*Math.PI);

				kontekst.moveTo(xy2d[0],xy2d[1]);

				//	Iscrtavanje grafika

				kontekst.lineTo(x2d[0],x2d[1]);
				kontekst.stroke();
				
		
 }



} //crtanjeGrafika
	
crtanjeGrafika(f1);
crtanjeGrafika(f2);
crtanjeGrafika(f3);
crtanjeGrafika(f4);
crtanjeGrafika(f5);



	// 3d transformacija koordinatnog sistema
	koordTacke=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
					koordTacke);

	kontekst.lineWidth=2/vc;	
	kontekst.strokeStyle = 'black';

	// iscrtavanje linija koordinatnog sistema
	for (var i=0;i<4;i++){
		
		
			kontekst.beginPath();
		
		crtLin(	persp(koordTacke[mapaLinija[i][0]])[0],persp(koordTacke[mapaLinija[i][0]])[1],
				persp(koordTacke[mapaLinija[i][1]])[0],persp(koordTacke[mapaLinija[i][1]])[1]);
	
		kontekst.stroke();
		kontekst.beginPath();
		
	}

	//podela na 5 podeoka od 0 do 5
	var podeociX=podeli_ose(xmin,xmax,7);
	var podeociF=podeli_ose(minMin,maxMax,7);
	kontekst.beginPath();
	var tp2d2=[];
	var tp2d2Y=[];
	var tp2d2Z=[];
	for (var i=0;i<podeociX.length;i++){
		var tpt=(podeociX[i]-xmin)/(xmax-xmin);

		var koordTemp=koordTacke;
		defKoordTacke2d();
		var tp3d=[	[tpt,koordTacke[mapaLinija[0][0]][1],koordTacke[mapaLinija[0][0]][2]],
					[tpt,koordTacke[mapaLinija[0][0]][1]-0.01,koordTacke[mapaLinija[0][0]][2]-0.01]];
		koordTacke=koordTemp;
		tp3d=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
						tp3d);
		var tp2d1=persp(tp3d[0]);
		tp2d2[i]=persp(tp3d[1]);
		kontekst.moveTo(tp2d1[0],tp2d1[1]);
		kontekst.lineTo(tp2d2[i][0],tp2d2[i][1]);
	}

		var kp = [[-1,-1],[1,-1],[1,1],[-1,1]];
		for (var i=0;i<podeociF.length;i++){
		var tpt=(podeociF[i]-minMin)/(maxMax-minMin);
		var koordTemp=koordTacke;
		defKoordTacke2d();
		var tp3d=[	[koordTacke[2][0],koordTacke[2][1],tpt],
					[koordTacke[2][0]+kp[2][0]*0.01,koordTacke[2][1]+kp[2][1]*0.01,tpt]];
		koordTacke=koordTemp;
		tp3d=transormacijaXNizTacaka(mnozenjeMatrica_n(transformacije),
						tp3d);

		var tp2d1=persp(tp3d[0]);
		tp2d2Z[i]=persp(tp3d[1]);
		kontekst.moveTo(tp2d1[0],tp2d1[1]);
		kontekst.lineTo(tp2d2Z[i][0],tp2d2Z[i][1]);
	}
	
	kontekst.stroke();

	
	kontekst.scale(2/sc,-2/vc); 				
	var velFonta=vc/50-dy/-4.5;
	kontekst.font=velFonta+"px Arial";
	kontekst.textBaseline="top";
	kontekst.fillStyle="black";
	for (var i=0;i<podeociX.length;i++){
		var podX=tp2d2[i][0]*sc/2-kontekst.measureText(podeociX[i]).width/2;
		
		var podF=-tp2d2[i][1]*vc/2+velFonta*0.15;
		kontekst.fillText(podeociX[i],podX,podF);
	}

	for (var i=0;i<podeociF.length;i++){
		kontekst.textBaseline="top";
		var podX=tp2d2Z[i][0]*sc/2+kontekst.measureText(zaok(korakF,podeociF[i])).width/2;
		kontekst.textBaseline="middle";
		var podF=-tp2d2Z[i][1]*vc/2+velFonta*0.15;
		kontekst.fillText(zaok(korakF,podeociF[i]),podX,podF);
	}

	kontekst.scale(sc/2,-vc/2); 				
	
	
	if (nt){
		grafik.selX=zaok(korak_x,koordGraf3d[ind][0]);
		grafik.selY=koordGraf3d[ind][1];
		grafik.selZ=koordGraf3d[ind][2];
		nacrtajTacku(koordGrafCanv[ind],4-(4-dy)/14);
	
		}

} //stem



var hh=0;
var korak;



	// Određivanje podeoka na osama
	function podeli_ose(min, max, broj_podeoka, xyz) {
		
		var opseg = max - min;
		korak = Math.pow(10, Math.floor(Math.log(opseg / broj_podeoka) / Math.log(10)));
		var greska = broj_podeoka / opseg * korak;
		
		// Zaokruživanje podeoka na pogodnije vrednosti
		if (greska <= .15) korak *= 10;
		else if (greska <= .35) korak *= 5;
		else if (greska <= .75) korak *= 2;
		
		// Zaokruživanje početne i krajnje vrednosti
		var  start = Math.ceil(min / korak) * korak,
			stop = Math.floor(max / korak) * korak + korak * 0.5,
			podeoci = [];
		//if (Math.abs(min/(start-korak))>0.999) {start=start-korak};
		
		if (xyz=="y") korakY=korak;
		if (xyz=="z") korakZ=korak;
		korakF=korak;
		// Upisivanje podeoka u niz
		for (var i=start; i < stop; i +=korak) {
			//if (i+korak>stopMath.abs((i+korak)/max)>0.999) stop=(i+korak)*1.5;
			//alert(Math.abs((i+korak)/max));
			i=zaok(korak,i);
			podeoci.push(i);  
		}
		return podeoci;
	}	//podeli_ose
	
	


}// Grafik